Imports System.security
Imports System.Security.permissions

'
' Used to test the Code Access Security of this assembly.  Without this
' test, you'd get the ugly message from the CLR.
'
Public Class TestPerm
    Public Function DoTestPerm() As Boolean
        Dim FilePerm As FileIOPermission
        Dim RegPerm As RegistryPermission
        Dim SecPerm As SecurityPermission
        Dim ps As PermissionSet
        Dim ans As Boolean

        ' Check the 3 main security requirements of this assembly

        ' we need read permission on all local files
        FilePerm = New FileIOPermission(PermissionState.None)
        FilePerm.AllLocalFiles = FileIOPermissionAccess.Read

        ' we need read permission on two major registry hives
        RegPerm = New RegistryPermission(PermissionState.None)
        RegPerm.AddPathList(RegistryPermissionAccess.Read, "HKEY_LOCAL_MACHINE;HKEY_CLASSES_ROOT")

        ' we need to make direct API calls
        SecPerm = New SecurityPermission(PermissionState.None)
        SecPerm.Flags = SecurityPermissionFlag.UnmanagedCode

        ' add 'em all together
        ps = New PermissionSet(PermissionState.None)
        ps.AddPermission(FilePerm)
        ps.AddPermission(RegPerm)
        ps.AddPermission(SecPerm)

        ' check it out
        ans = True
        Try
            ps.Demand()
        Catch ex As Exception
            ans = False
        End Try

        Return ans
    End Function
End Class
