'Add a Reference to Microsoft.Data.ConnectionUI.Dialog

'
' Configure the settings that appear in the config file.  Uses a custom
' ConfigXML to retrieve and set the values (since the "My.Settings" values
' are read only).
' Note: changes to settings do not go into effect until the program is
' restarted.
'
Public Class fmConfigure

    Private cfg As ConfigXML
    Private crypt As Crypt

    '
    ' Normally, you'd bind the controls to the My.Settings values, but in this
    ' case we might be loading values from another application (or want the
    ' default user-scope settings).
    '
    Public Sub LoadDefaults()
        LoadDefaults("", "SOSOS")
    End Sub

    Public Sub LoadDefaults(ByVal ConfigPath As String, ByVal AssemblyName As String)
        If ConfigPath = "" Then
            cfg = New ConfigXML
            crypt = New Crypt
        Else
            cfg = New ConfigXML(ConfigPath, AssemblyName)
            crypt = New Crypt(AssemblyName)
        End If

        ' The "Required Setting" tab
        cmbProvider.Text = cfg.GetValue(ConfigXML.Section.Application, "DatabaseProvider")
        cbEncrypt.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "EncryptConnectString"))
        If cbEncrypt.Checked Then
            tbConnect.Text = crypt.Decrypt(cfg.GetValue(ConfigXML.Section.Application, "ConnectionString"))
        Else
            tbConnect.Text = cfg.GetValue(ConfigXML.Section.Application, "ConnectionString")
        End If
        If tbErrLogFile.Enabled Then
            tbErrLogFile.Text = cfg.GetValue(ConfigXML.Section.Application, "ErrorLog")
            cmbErrLogLevel.Text = cfg.GetValue(ConfigXML.Section.Application, "ErrorLogLevel")
            cbUsePing.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "UsePingValidation"))
        End If

        ' The "Feature Selection" tab
        If cbAccounts.Enabled Then
            cbAccounts.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoAccounts"))
            cbAdmins.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoAdmins"))
            cbAutoUpdate.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoAutoUpdate"))
            cbBIOS.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoBIOS"))
            cbComponents.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoComponents"))
            cbCPU.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoCPU"))
            cbDesktop.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoDesktop"))
            cbDevices.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoDevices"))
            cbDisks.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoDisks"))
            cbDrives.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoDrives"))
            cbEmail.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoEmail"))
            cbEventLogSettings.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoEventLogSettings"))
            cbEventLogs.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoEventLogs"))
            cbFileInfo.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoFileInfo"))
            cbInternet.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoInternet"))
            cbMapped.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoMapped"))
            cbMemory.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoMemory"))
            cbModem.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoModem"))
            cbMonitor.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoMonitor"))
            cbMotherboard.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoMotherboard"))
            cbMouse.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoMouse"))
            cbNetAdapter.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoNetAdapter"))
            cbNetConfig.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoNetConfig"))
            cbOS.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoOS"))
            cbPC.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoPC"))
            cbPermissions.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoPermissions"))
            cbPorts.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoPorts"))
            cbPrinters.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoPrinters"))
            cbProcesses.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoProcesses"))
            cbProfiles.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoProfiles"))
            cbQFE.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoQFE"))
            cbRegistry.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoRegistry"))
            cbServices.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoServices"))
            cbShares.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoShares"))
            cbSoftware.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoSoftware"))
            cbStartup.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoStartup"))
            cbSystemDrivers.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoSystemDrivers"))
            cbSystemInfo.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoSystemInfo"))
            cbTasks.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoTasks"))
            cbUserLogin.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoUserLogin"))
            cbVideo.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoVideo"))
            cbVirus.Checked = CBool(cfg.GetValue(ConfigXML.Section.Application, "DoVirus"))
        End If

        ' The "Polling Defaults" tab
        If nudPollTimeout.Enabled Then
            nudPollTimeout.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "PollTimeout"))
            nudPoolSize.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "PoolSize"))
            tbPollLogDir.Text = cfg.GetValue(ConfigXML.Section.Application, "PollLogDirectory")
            cmbPollLogLevel.Text = cfg.GetValue(ConfigXML.Section.Application, "PollLogLevel")
            nudByAge.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "PollByAge"))
            tbPollByFileFile.Text = cfg.GetValue(ConfigXML.Section.Application, "PollByFileFile")
        End If
        If nudPoolSize.Enabled Then
            nudPoolSize.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "PoolSize"))
        End If
        If tbDomain.Enabled Then
            tbDomain.Text = cfg.GetValue(ConfigXML.Section.Application, "Domain")
            tbOUFilter.Text = cfg.GetValue(ConfigXML.Section.Application, "OU_Filter")
            tbNameFilter.Text = cfg.GetValue(ConfigXML.Section.Application, "NameFilter")
        End If

        ' The "Feature Settings" tab
        If nudEventsByLines.Enabled Then
            nudEventsByLines.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "EventsByLine"))
            nudEventsByDays.Value = CInt(cfg.GetValue(ConfigXML.Section.Application, "EventsByDay"))
            tbLastLoginFile.Text = cfg.GetValue(ConfigXML.Section.Application, "LastLoginFile")
            tbVersionFile.Text = cfg.GetValue(ConfigXML.Section.Application, "VersionFile")
            tbSUS_Server.Text = cfg.GetValue(ConfigXML.Section.Application, "SUS_Server")
            tbFileInfoList.Text = cfg.GetValue(ConfigXML.Section.Application, "FileInfoList")
            tbRegistryList.Text = cfg.GetValue(ConfigXML.Section.Application, "RegistryList")
        End If

        ' The "User Settings" tab
        If tbDefaultFont.Enabled Then
            tbDefaultFont.Text = cfg.GetValue(ConfigXML.Section.User, "DefaultFont")
        End If
        If cmbDefaultView.Enabled Then
            cmbDefaultView.Text = cfg.GetValue(ConfigXML.Section.User, "DefaultView")
            cbDefaultDoDetails.Checked = CBool(cfg.GetValue(ConfigXML.Section.User, "DefaultDoDetails"))
        End If

        ' The "Other" tab
        If cmbPollMethod.Enabled Then
            cmbPollMethod.Text = cfg.GetValue(ConfigXML.Section.Application, "PollMethod")
            tbPollLogFile.Text = cfg.GetValue(ConfigXML.Section.Application, "PollLogFile")
        End If
        If tbRunSOSOS.Enabled Then
            cmbGenerate.Text = cfg.GetValue(ConfigXML.Section.Application, "GenerateMethod")
            tbRunSOSOS.Text = cfg.GetValue(ConfigXML.Section.Application, "RunSOSOS_Path")
            tbViewSOSOS.Text = cfg.GetValue(ConfigXML.Section.Application, "ViewSOSOS_Path")
            cmbListView.Text = cfg.GetValue(ConfigXML.Section.User, "ListViewView")
        End If
    End Sub

    '
    ' Commit the changes to the config file
    '
    Private Sub bnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSave.Click
        cfg.SaveSettings()
        MsgBox("Changes do not go into effect until the configured program is restarted", MsgBoxStyle.Information, "Reminder")
        Me.Close()
    End Sub

    '
    ' Abandon any changes and exit
    '
    Private Sub bnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnClose.Click
        Me.Close()
    End Sub

    '
    ' Clear the Feature Selection list
    ' 
    Private Sub bnClearAll_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnClearAll.Click
        cbAccounts.Checked = False
        cbAdmins.Checked = False
        cbAutoUpdate.Checked = False
        cbBIOS.Checked = False
        cbComponents.Checked = False
        cbCPU.Checked = False
        cbDesktop.Checked = False
        cbDevices.Checked = False
        cbDisks.Checked = False
        cbDrives.Checked = False
        cbEmail.Checked = False
        cbEventLogSettings.Checked = False
        cbEventLogs.Checked = False
        cbFileInfo.Checked = False
        cbInternet.Checked = False
        cbMapped.Checked = False
        cbMemory.Checked = False
        cbModem.Checked = False
        cbMonitor.Checked = False
        cbMotherboard.Checked = False
        cbMouse.Checked = False
        cbNetAdapter.Checked = False
        cbNetConfig.Checked = False
        cbOS.Checked = False
        cbPC.Checked = False
        cbPermissions.Checked = False
        cbPorts.Checked = False
        cbPrinters.Checked = False
        cbProcesses.Checked = False
        cbProfiles.Checked = False
        cbQFE.Checked = False
        cbRegistry.Checked = False
        cbServices.Checked = False
        cbShares.Checked = False
        cbSoftware.Checked = False
        cbStartup.Checked = False
        cbSystemDrivers.Checked = False
        cbSystemInfo.Checked = False
        cbTasks.Checked = False
        cbUserLogin.Checked = False
        cbVideo.Checked = False
        cbVirus.Checked = False

        SetValueAll()
    End Sub

    '
    ' Set the Feature Selection list
    ' 
    Private Sub bnSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnSelectAll.Click
        cbAccounts.Checked = True
        cbAdmins.Checked = True
        cbAutoUpdate.Checked = True
        cbBIOS.Checked = True
        cbComponents.Checked = True
        cbCPU.Checked = True
        cbDesktop.Checked = True
        cbDevices.Checked = True
        cbDisks.Checked = True
        cbDrives.Checked = True
        cbEmail.Checked = True
        cbEventLogSettings.Checked = True
        cbEventLogs.Checked = True
        cbFileInfo.Checked = True
        cbInternet.Checked = True
        cbMapped.Checked = True
        cbMemory.Checked = True
        cbModem.Checked = True
        cbMonitor.Checked = True
        cbMotherboard.Checked = True
        cbMouse.Checked = True
        cbNetAdapter.Checked = True
        cbNetConfig.Checked = True
        cbOS.Checked = True
        cbPC.Checked = True
        cbPermissions.Checked = True
        cbPorts.Checked = True
        cbPrinters.Checked = True
        cbProcesses.Checked = True
        cbProfiles.Checked = True
        cbQFE.Checked = True
        cbRegistry.Checked = True
        cbServices.Checked = True
        cbShares.Checked = True
        cbSoftware.Checked = True
        cbStartup.Checked = True
        cbSystemDrivers.Checked = True
        cbSystemInfo.Checked = True
        cbTasks.Checked = True
        cbUserLogin.Checked = True
        cbVideo.Checked = True
        cbVirus.Checked = True

        SetValueAll()
    End Sub

    '
    ' Set all of the values for the "Set All" and "Clear All" buttons of the
    ' Feature Selection tab
    '
    Private Sub SetValueAll()
        cfg.SetValue(ConfigXML.Section.Application, "DoAccounts", cbAccounts.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoAdmins", cbAdmins.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoAutoUpdate", cbAutoUpdate.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoBIOS", cbBIOS.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoComponents", cbComponents.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoCPU", cbCPU.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoDesktop", cbDesktop.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoDevices", cbDevices.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoDisks", cbDisks.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoDrives", cbDrives.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoEmail", cbEmail.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoEventLogSettings", cbEventLogSettings.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoEventLogs", cbEventLogs.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoFileInfo", cbFileInfo.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoInternet", cbInternet.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoMapped", cbMapped.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoMemory", cbMemory.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoModem", cbModem.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoMonitor", cbMonitor.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoMotherboard", cbMotherboard.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoMouse", cbMouse.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoNetAdapter", cbNetAdapter.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoNetConfig", cbNetConfig.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoOS", cbOS.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoPC", cbPC.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoPermissions", cbPermissions.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoPorts", cbPorts.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoPrinters", cbPrinters.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoProcesses", cbProcesses.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", cbProfiles.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoQFE", cbQFE.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoRegistry", cbRegistry.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoServices", cbServices.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoShares", cbShares.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoSoftware", cbSoftware.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoStartup", cbStartup.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoSystemDrivers", cbSystemDrivers.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoSystemInfo", cbSystemInfo.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoTasks", cbTasks.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoUserLogin", cbUserLogin.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoVideo", cbVideo.Checked.ToString)
        cfg.SetValue(ConfigXML.Section.Application, "DoVirus", cbVirus.Checked.ToString)
    End Sub

    '
    ' Launch the database provider/connect string builder
    ' Note: Requires reference to Microsoft.Data.ConnectionUI and
    ' Microsoft.Data.ConnectionUI.Dialog.  These DLLs do NOT show in
    ' the list of available References, you must browse for them at
    ' C:\Program Files\Microsoft Visual Studio 8\Common7\IDE
    '
    Private Sub bnDbBuilder_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnDbBuilder.Click
        Dim d As New Microsoft.Data.ConnectionUI.DataConnectionDialog

        Microsoft.Data.ConnectionUI.DataSource.AddStandardDataSources(d)

        If Microsoft.Data.ConnectionUI.DataConnectionDialog.Show(d) = Windows.Forms.DialogResult.OK Then
            Dim CipherText As String

            cmbProvider.Text = d.SelectedDataProvider.Name
            tbConnect.Text = d.ConnectionString

            cfg.SetValue(ConfigXML.Section.Application, "DatabaseProvider", cmbProvider.Text)
            ' encrypt it before we save it?
            If cbEncrypt.Checked Then
                CipherText = crypt.Encrypt(tbConnect.Text)
            Else
                CipherText = tbConnect.Text
            End If
            cfg.SetValue(ConfigXML.Section.Application, "ConnectionString", CipherText)
        End If
    End Sub

    '
    ' Browse for a file to be used for the Error Log
    '
    Private Sub bnErrLogFile_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnErrLogFile.Click
        SaveFileDialog1.FileName = tbErrLogFile.Text
        SaveFileDialog1.AddExtension = True
        SaveFileDialog1.OverwritePrompt = False
        SaveFileDialog1.DefaultExt = ".txt"
        SaveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbErrLogFile.Text = SaveFileDialog1.FileName
            cfg.SetValue(ConfigXML.Section.Application, "ErrorLog", tbErrLogFile.Text)
        End If
    End Sub

    '
    ' Browse for a folder for the Polling Logfile
    '
    Private Sub bnLogDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnLogDir.Click
        FolderBrowserDialog1.ShowNewFolderButton = True
        FolderBrowserDialog1.SelectedPath = tbPollLogDir.Text
        If FolderBrowserDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbPollLogDir.Text = FolderBrowserDialog1.SelectedPath
            cfg.SetValue(ConfigXML.Section.Application, "PollLogDirectory", tbPollLogDir.Text)
        End If
    End Sub

    '
    ' Browse for a file used by the Poll By File screen
    '
    Private Sub bnPollByFile_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles bnPollByFile.Click
        OpenFileDialog1.FileName = tbPollByFileFile.Text
        OpenFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbPollByFileFile.Text = OpenFileDialog1.FileName
            cfg.SetValue(ConfigXML.Section.Application, "PollByFileFile", tbPollByFileFile.Text)
        End If
    End Sub

    '
    ' Browse for a font...
    '
    Private Sub bnFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnFont.Click
        Dim fc As New FontConverter
        FontDialog1.Font = CType(fc.ConvertFromString(tbDefaultFont.Text), Font)
        If FontDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbDefaultFont.Text = fc.ConvertToString(FontDialog1.Font)
            cfg.SetValue(ConfigXML.Section.User, "DefaultFont", tbDefaultFont.Text)
        End If
    End Sub

    '
    ' Browse for the full path of the Poll log file
    '
    Private Sub bnPollFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnPollFile.Click
        SaveFileDialog1.FileName = tbPollLogFile.Text
        SaveFileDialog1.AddExtension = True
        SaveFileDialog1.OverwritePrompt = False
        SaveFileDialog1.DefaultExt = ".txt"
        SaveFileDialog1.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbPollLogFile.Text = SaveFileDialog1.FileName
            cfg.SetValue(ConfigXML.Section.Application, "PollLogFile", tbPollLogFile.Text)
        End If
    End Sub

    '
    ' Browse for the RunSOSOS path
    '
    Private Sub bnRunSOSOS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnRunSOSOS.Click
        OpenFileDialog1.FileName = tbRunSOSOS.Text
        OpenFileDialog1.Filter = "Executable files (*.exe)|*.exe"
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbRunSOSOS.Text = OpenFileDialog1.FileName
            cfg.SetValue(ConfigXML.Section.Application, "RunSOSOS_Path", tbRunSOSOS.Text)
        End If
    End Sub

    '
    ' Browse for the ViewSOSOS path
    '
    Private Sub bnViewSOSOS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnViewSOSOS.Click
        OpenFileDialog1.FileName = tbViewSOSOS.Text
        OpenFileDialog1.Filter = "Executable files (*.exe)|*.exe"
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            tbViewSOSOS.Text = OpenFileDialog1.FileName
            cfg.SetValue(ConfigXML.Section.Application, "ViewSOSOS_Path", tbViewSOSOS.Text)
        End If
    End Sub

    '
    ' We use the Validating event to set the new values of the key/value
    ' pairs in the config file
    '

    Private Sub cbAccounts_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbAccounts.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoAccounts", cbAccounts.Checked.ToString)
    End Sub

    Private Sub cbAdmins_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbAdmins.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoAdmins", cbAdmins.Checked.ToString)
    End Sub

    Private Sub cbAutoUpdate_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbAutoUpdate.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoAutoUpdate", cbAutoUpdate.Checked.ToString)
    End Sub

    Private Sub cbBIOS_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbBIOS.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoBIOS", cbBIOS.Checked.ToString)
    End Sub

    Private Sub cbComponents_Validated(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbComponents.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoComponents", cbComponents.Checked.ToString)
    End Sub

    Private Sub cbCPU_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbCPU.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoCPU", cbCPU.Checked.ToString)
    End Sub

    Private Sub cbDevices_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbDevices.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoDevices", cbDevices.Checked.ToString)
    End Sub

    Private Sub cbDisks_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbDisks.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoDisks", cbDisks.Checked.ToString)
    End Sub

    Private Sub cbDrives_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbDrives.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoDrives", cbDrives.Checked.ToString)
    End Sub

    Private Sub cbEventLogSettings_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbEventLogSettings.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoEventLogSettings", cbEventLogSettings.Checked.ToString)
    End Sub

    Private Sub cbEncrypt_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbEncrypt.Validating
        cfg.SetValue(ConfigXML.Section.Application, "EncryptConnectString", cbEncrypt.Checked.ToString)
    End Sub

    ' Change the encryption of the Connection String
    Private Sub cbEncrypt_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbEncrypt.Click
        If cbEncrypt.Checked Then
            cfg.SetValue(ConfigXML.Section.Application, "ConnectionString", crypt.Encrypt(tbConnect.Text))
        Else
            cfg.SetValue(ConfigXML.Section.Application, "ConnectionString", tbConnect.Text)
        End If
    End Sub

    Private Sub cbEventLogs_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbEventLogs.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoEventLogs", cbEventLogs.Checked.ToString)
    End Sub

    Private Sub cbFileInfo_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbFileInfo.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoFileInfo", cbFileInfo.Checked.ToString)
    End Sub

    ' Mapped is dependent upon Profiles
    Private Sub cbMapped_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbMapped.Click
        If cbMapped.Checked Then
            cbProfiles.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", "True")
        End If
    End Sub

    Private Sub cbMapped_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbMapped.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoMapped", cbMapped.Checked.ToString)
    End Sub

    Private Sub cbMemory_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbMemory.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoMemory", cbMemory.Checked.ToString)
    End Sub

    Private Sub cbModem_Validated(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbModem.Validated
        cfg.SetValue(ConfigXML.Section.Application, "DoModem", cbModem.Checked.ToString)
    End Sub

    Private Sub cbMonitor_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbMonitor.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoMonitor", cbMonitor.Checked.ToString)
    End Sub

    Private Sub cbMotherboard_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbMotherboard.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoMotherboard", cbMotherboard.Checked.ToString)
    End Sub

    Private Sub cbMouse_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbMouse.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoMouse", cbMouse.Checked.ToString)
    End Sub

    Private Sub cbNetAdapter_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNetAdapter.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoNetAdapter", cbNetAdapter.Checked.ToString)
    End Sub

    Private Sub cbNetConfig_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbNetConfig.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoNetConfig", cbNetConfig.Checked.ToString)
    End Sub

    Private Sub cbOS_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbOS.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoOS", cbOS.Checked.ToString)
    End Sub

    Private Sub cbPC_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbPC.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoPC", cbPC.Checked.ToString)
    End Sub

    ' Permissions is dependent upon Shares
    Private Sub cbPermissions_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbPermissions.Click
        If cbPermissions.Checked Then
            cbShares.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoShares", "True")
        End If
    End Sub

    Private Sub cbPermissions_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbPermissions.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoPermissions", cbPermissions.Checked.ToString)
    End Sub

    Private Sub cbPorts_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbPorts.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoPorts", cbPorts.Checked.ToString)
    End Sub

    Private Sub cbPrinters_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbPrinters.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoPrinters", cbPrinters.Checked.ToString)
    End Sub

    Private Sub cbProcesses_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbProcesses.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoProcesses", cbProcesses.Checked.ToString)
    End Sub

    Private Sub cbQFE_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbQFE.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoQFE", cbQFE.Checked.ToString)
    End Sub

    Private Sub cbRegistry_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbRegistry.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoRegistry", cbRegistry.Checked.ToString)
    End Sub

    Private Sub cbServices_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbServices.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoServices", cbServices.Checked.ToString)
    End Sub

    ' Shares has Permissions as a dependent child
    Private Sub cbShares_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbShares.Click
        If Not cbShares.Checked Then
            cbPermissions.Checked = False
            cfg.SetValue(ConfigXML.Section.Application, "DoPermissions", "True")
        End If
    End Sub

    Private Sub cbShares_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbShares.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoShares", cbShares.Checked.ToString)
    End Sub

    Private Sub cbSoftware_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbSoftware.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoSoftware", cbSoftware.Checked.ToString)
    End Sub

    Private Sub cbSystemInfo_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbSystemInfo.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoSystemInfo", cbSystemInfo.Checked.ToString)
    End Sub

    Private Sub cbTasks_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbTasks.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoTasks", cbTasks.Checked.ToString)
    End Sub

    Private Sub cbUsePing_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbUsePing.Validating
        cfg.SetValue(ConfigXML.Section.Application, "UsePingValidation", cbUsePing.Checked.ToString)
    End Sub

    Private Sub cbUserLogin_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbUserLogin.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoUserLogin", cbUserLogin.Checked.ToString)
    End Sub

    Private Sub cbVideo_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbVideo.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoVideo", cbVideo.Checked.ToString)
    End Sub

    Private Sub cbVirus_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbVirus.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoVirus", cbVirus.Checked.ToString)
    End Sub

    Private Sub cmbErrLogLevel_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbErrLogLevel.Validating
        cfg.SetValue(ConfigXML.Section.Application, "ErrorLogLevel", cmbErrLogLevel.Text)
    End Sub

    Private Sub cmbPollLogLevel_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbPollLogLevel.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollLogLevel", cmbPollLogLevel.Text)
    End Sub

    Private Sub cmbProvider_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbProvider.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DatabaseProvider", cmbProvider.Text)
        If cmbProvider.Text = "None" Then
            tbConnect.Text = ""
            cfg.SetValue(ConfigXML.Section.Application, "ConnectionString", "")
        End If
    End Sub

    Private Sub nudByAge_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles nudByAge.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollByAge", nudByAge.Value.ToString)
    End Sub

    Private Sub nudEventsByDays_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles nudEventsByDays.Validating
        cfg.SetValue(ConfigXML.Section.Application, "EventsByDay", nudEventsByDays.Value.ToString)
    End Sub

    Private Sub nudEventsByLines_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles nudEventsByLines.Validating
        cfg.SetValue(ConfigXML.Section.Application, "EventsByLine", nudEventsByLines.Value.ToString)
    End Sub

    Private Sub nudPollTimeout_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles nudPollTimeout.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollTimeout", nudPollTimeout.Value.ToString)
    End Sub

    Private Sub nudPoolSize_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles nudPoolSize.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PoolSize", nudPoolSize.Value.ToString)
    End Sub

    Private Sub tbConnect_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbConnect.Validating
        Dim CipherText As String

        ' encrypt it before we save it?
        If cbEncrypt.Checked Then
            CipherText = crypt.Encrypt(tbConnect.Text)
        Else
            CipherText = tbConnect.Text
        End If
        cfg.SetValue(ConfigXML.Section.Application, "ConnectionString", CipherText)
    End Sub

    Private Sub tbDomain_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbDomain.Validating
        cfg.SetValue(ConfigXML.Section.Application, "Domain", tbDomain.Text)
    End Sub

    Private Sub tbErrLogFile_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbErrLogFile.Validating
        cfg.SetValue(ConfigXML.Section.Application, "ErrorLog", tbErrLogFile.Text)
    End Sub

    Private Sub tbFileInfoList_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbFileInfoList.Validating
        cfg.SetValue(ConfigXML.Section.Application, "FileInfoList", tbFileInfoList.Text & vbCr)
    End Sub

    Private Sub tbLastLoginFile_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbLastLoginFile.Validating
        cfg.SetValue(ConfigXML.Section.Application, "LastLoginFile", tbLastLoginFile.Text)
    End Sub

    Private Sub tbPollLogDir_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbPollLogDir.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollLogDirectory", tbPollLogDir.Text)
    End Sub

    Private Sub tbNameFilter_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbNameFilter.Validating
        cfg.SetValue(ConfigXML.Section.Application, "NameFilter", tbNameFilter.Text)
    End Sub

    Private Sub tbOUFilter_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbOUFilter.Validating
        cfg.SetValue(ConfigXML.Section.Application, "OU_Filter", tbOUFilter.Text)
    End Sub

    Private Sub tbPollByFileFile_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbPollByFileFile.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollByFileFile", tbPollByFileFile.Text)
    End Sub

    Private Sub tbRegistryList_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbRegistryList.Validating
        cfg.SetValue(ConfigXML.Section.Application, "RegistryList", tbRegistryList.Text & vbCr)
    End Sub

    Private Sub tbSUS_Server_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbSUS_Server.Validating
        cfg.SetValue(ConfigXML.Section.Application, "SUS_Server", tbSUS_Server.Text)
    End Sub

    Private Sub tbVersionFile_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbVersionFile.Validating
        cfg.SetValue(ConfigXML.Section.Application, "VersionFile", tbVersionFile.Text)
    End Sub

    Private Sub cmbDefaultView_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbDefaultView.Validating
        cfg.SetValue(ConfigXML.Section.User, "DefaultView", cmbDefaultView.Text)
    End Sub

    Private Sub cbDefaultDoDetails_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbDefaultDoDetails.Validating
        cfg.SetValue(ConfigXML.Section.User, "DefaultDoDetails", cbDefaultDoDetails.Checked.ToString)
    End Sub

    Private Sub tbDefaultFont_Validated(ByVal sender As Object, ByVal e As System.EventArgs) Handles tbDefaultFont.Validated
        cfg.SetValue(ConfigXML.Section.User, "DefaultFont", tbDefaultFont.Text)
    End Sub

    Private Sub cmbPollMethod_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbPollMethod.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollMethod", cmbPollMethod.Text)
    End Sub

    ' Desktop is dependent upon Profiles
    Private Sub cbDesktop_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbDesktop.Click
        If cbDesktop.Checked Then
            cbProfiles.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", "True")
        End If
    End Sub

    Private Sub cbDesktop_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbDesktop.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoDesktop", cbDesktop.Checked.ToString)
    End Sub

    ' Email is dependent upon Profiles
    Private Sub cbEmail_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbEmail.Click
        If cbEmail.Checked Then
            cbProfiles.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", "True")
        End If
    End Sub

    Private Sub cbEmail_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbEmail.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoEmail", cbEmail.Checked.ToString)
    End Sub

    ' Internet is dependent upon Profiles
    Private Sub cbInternet_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbInternet.Click
        If cbInternet.Checked Then
            cbProfiles.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", "True")
        End If
    End Sub

    Private Sub cbInternet_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbInternet.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoInternet", cbInternet.Checked.ToString)
    End Sub

    ' Profiles has several dependent children
    Private Sub cbProfiles_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbProfiles.Click
        If Not cbProfiles.Checked Then
            cbDesktop.Checked = False
            cbEmail.Checked = False
            cbInternet.Checked = False
            cbMapped.Checked = False
            cbStartup.Checked = False
            cfg.SetValue(ConfigXML.Section.Application, "DoDesktop", "False")
            cfg.SetValue(ConfigXML.Section.Application, "DoEmail", "False")
            cfg.SetValue(ConfigXML.Section.Application, "DoInternet", "False")
            cfg.SetValue(ConfigXML.Section.Application, "DoMapped", "False")
            cfg.SetValue(ConfigXML.Section.Application, "DoStartup", "False")
        End If
    End Sub

    Private Sub cbProfiles_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbProfiles.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", cbProfiles.Checked.ToString)
    End Sub

    Private Sub cbStartup_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbStartup.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoStartup", cbStartup.Checked.ToString)
    End Sub

    Private Sub cbSystemDrivers_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cbSystemDrivers.Validating
        cfg.SetValue(ConfigXML.Section.Application, "DoSystemDrivers", cbSystemDrivers.Checked.ToString)
    End Sub

    ' Startup is dependent upon Profiles
    Private Sub cbStartup_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cbStartup.Click
        If cbStartup.Checked Then
            cbProfiles.Checked = True
            cfg.SetValue(ConfigXML.Section.Application, "DoProfiles", "True")
        End If
    End Sub

    Private Sub tbPollLogFile_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbPollLogFile.Validating
        cfg.SetValue(ConfigXML.Section.Application, "PollLogFile", tbPollLogFile.Text)
    End Sub

    Private Sub cmbGenerate_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbGenerate.Validating
        cfg.SetValue(ConfigXML.Section.Application, "GenerateMethod", cmbGenerate.Text)
    End Sub

    Private Sub cmbListView_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles cmbListView.Validating
        cfg.SetValue(ConfigXML.Section.User, "ListViewView", cmbListView.Text)
    End Sub

    Private Sub tbRunSOSOS_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbRunSOSOS.Validating
        cfg.SetValue(ConfigXML.Section.Application, "RunSOSOS_Path", tbRunSOSOS.Text)
    End Sub

    Private Sub tbViewSOSOS_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles tbViewSOSOS.Validating
        cfg.SetValue(ConfigXML.Section.Application, "ViewSOSOS_Path", tbViewSOSOS.Text)
    End Sub

End Class